Improved test framework and test for hardlink handling
authorMartin Pool <mbp@samba.org>
Fri, 11 Jan 2002 07:11:23 +0000 (07:11 +0000)
committerMartin Pool <mbp@samba.org>
Fri, 11 Jan 2002 07:11:23 +0000 (07:11 +0000)
runtests.sh
testsuite/hardlinks.test
testsuite/rsync.fns

index ab6f77a..5d3af1b 100755 (executable)
@@ -1,6 +1,6 @@
 #! /bin/sh
 
-# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
+# Copyright (C) 2001, 2002 by Martin Pool <mbp@samba.org>
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License version
@@ -160,16 +160,25 @@ missing=0
 passed=0
 failed=0
 
-scratchdir="`pwd`"/testtmp
-echo "    scratchdir=$scratchdir"
+# Prefix for scratch directory.  We create separate directories for
+# each test case, so that they can be left behind in case of failure
+# to aid investigation.
+scratchbase="`pwd`"/testtmp
+echo "    scratchbase=$scratchbase"
 
 suitedir="$srcdir/testsuite"
 
 export scratchdir suitedir
 
-clean_scratch() {
+prep_scratch() {
     [ -d "$scratchdir" ] && rm -rf "$scratchdir"
     mkdir "$scratchdir"
+    return 0
+}
+
+discard_scratch() {
+    [ -d "$scratchdir" ] && rm -rf "$scratchdir"
+    return 0
 }
 
 if [ "x$whichtests" = x ]
@@ -179,32 +188,38 @@ fi
 
 for testscript in $suitedir/$whichtests
 do
-    testbase=`echo $testscript | sed 's!.*/!!'`
+    testbase=`echo $testscript | sed 's!.*/!!' | sed -e 's/.test\$//'`
+    scratchdir="$scratchbase.$testbase"
 
     echo "----- $testbase starting"
-    clean_scratch
+    prep_scratch
 
-    if sh $RUNSHFLAGS "$testscript" >"$scratchdir/test.log"  2>&1
-    then
+    set +e
+    sh $RUNSHFLAGS "$testscript" >"$scratchdir/test.log" 2>&1
+    result=$?
+    set -e
+
+    case $result in
+    0)
        echo "----- $testbase completed successfully"
        passed=`expr $passed + 1`
-    else 
-       case $? in
-       77)
-           echo "----- $testbase skipped"
-           skipped=`expr $skipped + 1`
-           ;;
-       *)
-           echo "----- $testbase failed: log follows"
-           cat "$scratchdir/test.log"
-           echo "----- $testbase log ends"
-           failed=`expr $failed + 1`
-           if [ "x$nopersist" = "xyes" ]
-           then
-               exit 1
-           fi
-       esac
-    fi
+       discard_scratch
+       ;;
+    77)
+       echo "----- $testbase skipped"
+       skipped=`expr $skipped + 1`
+       discard_scratch
+       ;;
+    *)
+       echo "----- $testbase failed: log follows"
+       cat "$scratchdir/test.log"
+       echo "----- $testbase log ends"
+       failed=`expr $failed + 1`
+       if [ "x$nopersist" = "xyes" ]
+       then
+           exit 1
+       fi
+    esac
 done
 
 echo '------------------------------------------------------------'
index 5cdc78f..3405f15 100644 (file)
@@ -31,7 +31,7 @@ ln "$name1" "$name2" || fail "Can't create hardlink"
 ln "$name2" "$name3" || fail "Can't create hardlink"
 cp "$name2" "$name4" || fail "Can't copy file"
 
-checkit "rsync -aH \"$fromdir/\" \"$todir/\"" "$fromdir" "$todir"
+checkit "rsync -aHvv \"$fromdir/\" \"$todir/\"" "$fromdir" "$todir"
 
 exit 0
 # last [] may have failed but if we get here then we've won
index c321dd3..2d27a8c 100644 (file)
@@ -135,35 +135,31 @@ makepath () {
 # there are any difference.  If there are, explain them.
 
 checkit() {
-    log=${LOG}
     failed=
-    # the log accumulates all output; we only display it if there 
-    # is a problem.
 
-    echo "Running: \"$1\""  >${log}
-    echo "">>${log}
-    eval "$1"  >>${log} 2>&1
+    # We can just write everything to stdout/stderr, because the
+    # wrapper hides it unless there is a problem.
+
+    echo "Running: \"$1\""  
+    eval "$1" 
     status=$?
     if [ $status != 0 ]; then
        failed="YES";
     fi
 
-    echo "-------------">>${log}
-    echo "check how the files compare with diff:">>${log}
-    echo "">>${log}
-    diff -cr $2 $3 >>${log} 2>&1 || failed=YES
-    echo "-------------">>${log}
-    echo "check how the directory listings compare with diff:">>${log}
-    echo "">>${log}
-    ( cd "$2" && rsync_ls_lR . ) > ${TMP}/ls-from 2>>${log}
-    ( cd "$3" && rsync_ls_lR . ) > ${TMP}/ls-to  2>>${log}
-    diff -c ${TMP}/ls-from ${TMP}/ls-to >>${log} 2>&1 || failed=YES
+    echo "-------------"
+    echo "check how the files compare with diff:"
+    echo ""
+    diff -cr $2 $3 || failed=YES
+    echo "-------------"
+    echo "check how the directory listings compare with diff:"
+    echo ""
+    ( cd "$2" && rsync_ls_lR . ) > ${TMP}/ls-from 
+    ( cd "$3" && rsync_ls_lR . ) > ${TMP}/ls-to 
+    diff -c ${TMP}/ls-from ${TMP}/ls-to || failed=YES
     if [ -z "${failed}" ] ; then
-       rm $log
        return 0
     else
-       cat ${log}
-       rm ${log}
        return 1
     fi
 }